﻿Imports System
Imports System.IO.Ports

Public Class Form1

    'Dim data As String = ""

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Button1.Text = "Connect"
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        If SerialPort1.IsOpen = False Then

            SerialPort1.Open()
            Button1.Text = "Disconnect"
        Else

            SerialPort1.Close()
            Button1.Text = "Connect"

        End If

    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        Dim SW As New SerialWork(AddressOf SerialWorkProcedure)
        SW.BeginInvoke(SerialPort1, Nothing, Nothing)

    End Sub

    Private Delegate Sub SerialWork(ByVal Serial As System.IO.Ports.SerialPort)
    Private Delegate Sub SetReadSerialData(ByVal data As String)
    Dim DataReceived As String = ""

    Private Sub SerialWorkProcedure(ByVal Serial As System.IO.Ports.SerialPort)
        If SerialPort1.IsOpen Then
            Dim _DataReceived As String = SerialPort1.ReadExisting()
            ReadSerialData(_DataReceived)
        End If
    End Sub

    Private Sub ReadSerialData(ByVal data As String)
        If Me.InvokeRequired Then
            Try
                Dim RSD As New SetReadSerialData(AddressOf ReadSerialData)
                Me.Invoke(RSD, data)
            Catch generatedExceptionName As Exception
            End Try
        Else
            'inja dade vojud darad! 
            DataReceived += data
            TextBox1.Text += DataReceived
            data = ""
            DataReceived = ""

        End If
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        SerialPort1.PortName = ComboBox1.Text
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        SerialPort1.Close()
    End Sub

End Class
